package com.nisum.omd.service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Random;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.github.javafaker.Faker;
import com.nisum.omd.domain.LineItem;
import com.nisum.omd.domain.Order;
import java.time.temporal.ChronoUnit;


@Component
public class RandomDataGeneratorImpl implements RandomDataGenerator {

	@Autowired
	private Order order;
	@Autowired
	private Faker faker;
	
	public String generateOrderNumber() {
		return String.valueOf(faker.number().numberBetween(1000000, 9999999));
	}

	@Override
	public String generateCustomerId() {
		return String.valueOf(faker.number().numberBetween(1, 1000));
	}
	
	@Override
	public LineItem genetateLineItem(LineItem lineItem) {
		List<String> productNames = new ArrayList<String>();
		productNames.add("Easy Heavyweight T-Shirt");
		productNames.add("Classic stripe T-Shirt");
		productNames.add("Icon denim jacket");
		productNames.add("Graphic crewneck T-Shirt");
		productNames.add("Classic V T-Shirt");
		
		Random random = new Random(); 
		int randomIndex = random.nextInt(productNames.size());
		String randomElement = productNames.get(randomIndex);
		lineItem.setProductName(randomElement);
		Date weekBefore = Date.from(order.getOrderDate().toInstant().plus(5, ChronoUnit.DAYS));
		lineItem.setEstimatedShipDate(weekBefore);
		return lineItem;
	}

	@Override
	public List<Double> generateIntervals() {
		List<Double> timeIntervals = new ArrayList<Double>();
		timeIntervals.add(0.10);
		timeIntervals.add(0.20);
		timeIntervals.add(0.30);
		timeIntervals.add(0.40);
		return timeIntervals;
	}
	
}
