import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
//import { Orders } from './orders';
import { Observable } from 'rxjs';
import { Orders } from '../orders';
const API_URL = 'http://localhost:9009/api/test/';

const TOKEN_KEY = 'auth-token';
const USER_KEY = 'auth-user';

@Injectable({
  providedIn: 'root'
})
export class DashboardService {

  constructor(private http:HttpClient) { }

  public saveToken(token: string) {
    window.sessionStorage.removeItem(TOKEN_KEY);
    window.sessionStorage.setItem(TOKEN_KEY, token);
  }

  public getToken(): string {
    return sessionStorage.getItem(TOKEN_KEY);
  }

  getTeamMembersSummary(): any[]
  {
    console.log("called");
    var TeamMembersSummary = [
      { Region: "East", TeamMembersCount: 20, TemporarilyUnavailableMembers: 4 }      
    ];
    return TeamMembersSummary;
  }
  getData(){
    return this.http.get('https://jsonplaceholder.typicode.com/users/1');
  }

  getOrders(): Observable<any> {
    return this.http.get(API_URL + 'getOrdersSummary', { responseType: 'json' });
  }
    getTopOrdersFrmApi():Observable<Orders[]>
  {
    return this.http.get<Orders[]>(API_URL + 'getWeekOrders', {responseType: 'json'});
  }
  getTopOrders(): any[]
  {
    var OrdersSummary = [
      { "orderNum":"100ORD1", "customerId":"1025321", "orderPrice":"995.00","orderDate":"29/04/2020 11:25:36","productName":"Priya","orderedQty":"2" },
      { "orderNum":"100ORD2", "customerId":"1025322", "orderPrice":"45.00","orderDate":"29/04/2020 12:25:36","productName":"Liril","orderedQty":"5" },
      { "orderNum":"100ORD1", "customerId":"1025321", "orderPrice":"995.00","orderDate":"29/04/2020 11:25:36","productName":"Priya","orderedQty":"2" },
      { "orderNum":"100ORD2", "customerId":"1025322", "orderPrice":"45.00","orderDate":"29/04/2020 12:25:36","productName":"Liril","orderedQty":"5" },
      { "orderNum":"100ORD1", "customerId":"1025321", "orderPrice":"995.00","orderDate":"29/04/2020 11:25:36","productName":"Priya","orderedQty":"2" },
      { "orderNum":"100ORD2", "customerId":"1025322", "orderPrice":"45.00","orderDate":"29/04/2020 12:25:36","productName":"Liril","orderedQty":"5" },
      { "orderNum":"100ORD1", "customerId":"1025321", "orderPrice":"995.00","orderDate":"29/04/2020 11:25:36","productName":"Priya","orderedQty":"2" },
      { "orderNum":"100ORD2", "customerId":"1025322", "orderPrice":"45.00","orderDate":"29/04/2020 12:25:36","productName":"Liril","orderedQty":"5" },
      { "orderNum":"100ORD1", "customerId":"1025321", "orderPrice":"995.00","orderDate":"29/04/2020 11:25:36","productName":"Priya","orderedQty":"2" },
      { "orderNum":"100ORD2", "customerId":"1025322", "orderPrice":"45.00","orderDate":"29/04/2020 12:25:36","productName":"Liril","orderedQty":"5" }
      
    ];
    return OrdersSummary;
  }
  getWeeklyOrders(): any[]
  {
    var weeklyOrdersSummary = [
      { "orderDate":"30-04-2020", "orderCount":"1025321" },
      { "orderDate":"29-04-2020", "orderCount":"10322" },
      { "orderDate":"28-04-2020", "orderCount":"4025321" },
      { "orderDate":"27-04-2020", "orderCount":"105322" },
      { "orderDate":"26-04-2020", "orderCount":"2025321" },
      { "orderDate":"25-04-2020", "orderCount":"302322" },
      { "orderDate":"24-04-2020", "orderCount":"7025522" }
      
    ];
    return weeklyOrdersSummary;
  }
}
