import { Component, OnInit } from '@angular/core';
import { ViewEncapsulation } from '@angular/core';
import { TokenStorageService } from '../_services/token-storage.service';
import { DashboardService } from '../_services/dashboard.service';
import { interval, Observable } from 'rxjs';
import { mergeMap, map } from 'rxjs/operators';
import * as Chart from 'chart.js';
import { GoogleChartService } from '../_services/google-chart.service';
import { Orders } from '../orders';



@Component({
  selector: 'app-dashboard',
  templateUrl: './dashboard.component.html',
  styleUrls: ['../app.component.scss','./dashboard.component.scss'],
  encapsulation: ViewEncapsulation.None
})
export class DashboardComponent implements OnInit {

  Username: string;
  Orders:any;
  OrdersData:any;
  title = 'angular8chartjs';
    canvas: any;
    ctx: any;
    private gLib: any;
    orders: [][];
    WeekOrders:any;
    ordwk: Observable<Orders[]>;
     OrdersArray1: (string | number)[][]=[];
     OrdersArray2: (string | number)[][]=[];
     orddate1:string;
   ordcount1:number;
    
    OrdersCountArray: (string | number)[][]=[['22-04-2020', 7],
    ['23-04-2020', 6],
    ['24-04-2020', 8],
    ['25-04-2020', 9],
    ['26-04-2020', 6],
    ['27-04-2020', 8],
    ['28-04-2020', 5]];

   
    //values: Array<string> = ['Apple', 2, 'Orange', 3, 4, 'Banana']; 

    //this.orders.addColumn(['Date', 'Orders']);
   
  constructor(private tokenStorageService: TokenStorageService,private dashboardService: DashboardService,private gChartService : GoogleChartService) { 
    this.gLib = this.gChartService.getGoogle();
    this.gLib.charts.load('current', {'packages':['corechart','table']});
    this.gLib.charts.setOnLoadCallback(this.drawChart.bind(this));
    this.gLib.charts.setOnLoadCallback(this.drawBarChart.bind(this));

  }

  ngOnInit() {

    if(this.Orders==null)
    {
 this.Orders=this.dashboardService.getData();
 

    this.dashboardService.getOrders().subscribe(
      data => {
        this.Orders = data;
        console.log("DATA:::"+data);
      },
      err => {
        this.Orders = JSON.parse(err.error).message;
      }
    );
    }

    interval(1 * 3 * 1000)
    .pipe(
      mergeMap(() => this.dashboardService.getOrders())
    )
    .subscribe(data => this.Orders=data);

    const user = this.tokenStorageService.getUser();
    this.Username = user.username;
   
    this.ordwk=this.dashboardService.getTopOrdersFrmApi();
    let date1:string;
    let date2:string;
    let date3:string;
    let date4:string;
    let date5:string;
    let date6:string;
    let date7:string;
    let day1count:number;
    let day2count:number;
    let day3count:number;
    let day4count:number;
    let day5count:number;
    let day6count:number;
    let day7count:number;
    
    
 
    console.log("WEEEKKS:::"+this.OrdersCountArray);
   
      this.canvas = document.getElementById('myChart');
      this.ctx = this.canvas.getContext('2d');
      let myChart = new Chart(this.ctx, {
        type: 'pie',
        data: {
            labels: ["New", "In Progress", "On Hold"],
            datasets: [{
                label: '# of Votes',
                data: [1,2,3],
                backgroundColor: [
                    'rgba(255, 99, 132, 1)',
                    'rgba(54, 162, 235, 1)',
                    'rgba(255, 206, 86, 1)'
                ],
                borderWidth: 1
            }]
        },
        options: {
          responsive: false,
         // display:true
        }
      });
    }

    private drawChart(){
      let chart = new this.gLib.visualization.PieChart(document.getElementById('divPieChart'));
      let data = new this.gLib.visualization.DataTable();
      data.addColumn('string', 'Date');
      data.addColumn('number', 'Count');
     // for(int i=0;i<=)
      data.addRows(this.OrdersCountArray);
  
      let options = {'title':'Weekly Order History','width':650, 'height':500};
  
      chart.draw(data, options);
    }

    private drawBarChart(){
      let oddate: string = "hari";
      let value0: Array<string | number> ;
      this.ordwk=this.dashboardService.getTopOrdersFrmApi();
     
      this.ordwk.forEach(element => {
        let a=element[0].oderDate;
        console.log(element[0].oderDate);
        console.log(element[0].orderCount);
        console.log(element[1].oderDate);
        console.log(element[1].orderCount);
        oddate=element[0].oderDate.toString();
        this.orddate1=element[0].oderDate;
        this.ordcount1=element[0].orderCount;
        this.OrdersArray1.push([element[0].oderDate,element[0].orderCount])
        value0=[element[0].oderDate,element[0].orderCount];
      }); 
      console.log("VALLL:::"+value0);
      console.log("oddate:::"+oddate);
      console.log("ord:::"+this.orddate1);
      console.log("cnt:::"+this.ordcount1);
      console.log("OrdersArray1:::"+this.OrdersArray1);
      
      let values1: Array<string | number> = ['30-04-2020', 5602];
      let values2: Array<string | number> = ['26-04-2020', 1512];
      let values3: Array<string | number> = ['25-04-2020', 1678];
      let values4: Array<string | number> = ['24-04-2020', 2020];
      let values5: Array<string | number> = ['23-04-2020', 6512];
      let values6: Array<string | number> = ['22-04-2020', 6312];
      let values7: Array<string | number> = ['21-04-2020', 4516];

     let data = this.gLib.visualization.arrayToDataTable([
        ['Date', 'Orders'],
        values1,
        values2,
        values3,
        values4,
        values5,
        values6,
        values7
      ]);
  
      let options = {'title':'Date & Orders',
                      'width': '150%',
                      'height': '100%'};
  
      let chart = new this.gLib.visualization.ColumnChart(document.getElementById('divLineChart'));
  
      chart.draw(data, options);
    }

}
