package com.nisum.omd.repository;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import com.mongodb.client.DistinctIterable;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoCursor;
import com.nisum.omd.dto.Order;
@Repository

public class OrderRepositoryCustomImpl implements OrderRepositoryCustom {

    private final MongoTemplate mongoTemplate;

    @Autowired
    public OrderRepositoryCustomImpl(MongoTemplate mongoTemplate) {
        this.mongoTemplate = mongoTemplate;
    }

    @Override
    public Long query(DynamicQuery dynamicQuery) {

        final Query query = new Query();
        final List<Criteria> criteria = new ArrayList<>();
        if(dynamicQuery.getOrderDateFrom() != null) {
            criteria.add(Criteria.where("orderDate").gte(dynamicQuery.getOrderDateFrom()));
        }
        if(dynamicQuery.getOrderDateTo() != null) {
            criteria.add(Criteria.where("orderDate").lte(dynamicQuery.getOrderDateTo()));
        }
        if(!criteria.isEmpty()) {
            query.addCriteria(new Criteria().andOperator(criteria.toArray(new Criteria[criteria.size()])));
        }
        long OrderCount = mongoTemplate.count(query, Order.class);;

        List<Order> orderList = mongoTemplate.find(query, Order.class);


        return OrderCount;
    }
    public List<String> queryCustomerCount() {
        List<String> categoryList = new ArrayList<>();
        MongoCollection mongoCollection = mongoTemplate.getCollection("orders");
        DistinctIterable distinctIterable = mongoCollection.distinct("customerId",String.class);
        MongoCursor cursor = distinctIterable.iterator();
        while (cursor.hasNext()) {
            String category = (String)cursor.next();
            categoryList.add(category);
        }
        return categoryList;
    }
}

