package com.nisum.omd.service;

import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.stereotype.Service;

import com.nisum.omd.dto.WeeklyOrders;
import com.nisum.omd.pojo.OrdersSummary;
import com.nisum.omd.repository.DynamicQuery;
import com.nisum.omd.repository.OrdersSummaryRepository;
@Service
public class OrdersSummaryServiceImpl  implements OrdersSummaryService {


	@Autowired
	MongoTemplate mongoTemplate;


    @Autowired
   private OrdersSummaryRepository ordersSummaryRepository;
    static long minuteCount = 0;
	static long HrCount = 0;
	static long dayCount = 0;
	static int cutomers = 0;

    private Long orderCountInMinute(){

        LocalDateTime localTime = LocalDateTime.now();

        LocalTime fromMin = LocalTime.of(localTime.getHour(), localTime.getMinute(),00);
        LocalTime toMin  = LocalTime.of(localTime.getHour(), localTime.getMinute(),59);
        Instant instant = fromMin .atDate(LocalDate.now()).
                atZone(ZoneId.systemDefault()).toInstant();
        Date time1 = Date.from(instant);
        Long fromMinute=time1.getTime();

        Instant instant2 = toMin .atDate(LocalDate.now()).
                atZone(ZoneId.systemDefault()).toInstant();
        Date time2 = Date.from(instant2);
        Long toMinute=time2.getTime();

        DynamicQuery dynamicQuery = new DynamicQuery();
        dynamicQuery.setOrderDateFrom(fromMinute);
        dynamicQuery.setOrderDateTo(toMinute);

        Long orderCount = ordersSummaryRepository.query(dynamicQuery);

        return orderCount;

    }
    private Long orderCountInHour(){
        LocalDateTime localTime = LocalDateTime.now();

        LocalTime fromHr = LocalTime.of(localTime.getHour(), 00,00);
        LocalTime toHr = LocalTime.of(localTime.getHour(), 59,59);
        Instant instant = fromHr.atDate(LocalDate.now()).
                atZone(ZoneId.systemDefault()).toInstant();
        Date time1 = Date.from(instant);
        Long fromHour=time1.getTime();

        Instant instant2 = toHr.atDate(LocalDate.now()).
                atZone(ZoneId.systemDefault()).toInstant();
        Date time2 = Date.from(instant2);
        Long toHour=time2.getTime();

        DynamicQuery dynamicQuery = new DynamicQuery();
        dynamicQuery.setOrderDateFrom(fromHour);
        dynamicQuery.setOrderDateTo(toHour);

        Long orderCount = ordersSummaryRepository.query(dynamicQuery);

        return orderCount;
    }
    private Long orderCountInDay(){

        LocalTime fromdt = LocalTime.of(00, 00,00);
        LocalTime todt = LocalTime.of(23, 59,59);

        Instant instant = fromdt.atDate(LocalDate.now()).
                atZone(ZoneId.systemDefault()).toInstant();
        Date time1 = Date.from(instant);
        Long fromDate=time1.getTime();

        Instant instant2 = todt.atDate(LocalDate.now()).
                atZone(ZoneId.systemDefault()).toInstant();
        Date time2 = Date.from(instant2);
        Long toDate=time2.getTime();

        DynamicQuery dynamicQuery = new DynamicQuery();
        dynamicQuery.setOrderDateFrom(fromDate);
        dynamicQuery.setOrderDateTo(toDate);

       Long orderCount = ordersSummaryRepository.query(dynamicQuery);

        return orderCount;
    }
    
    private Long toDate() {
        LocalTime todt = LocalTime.of(23, 59,59);
        Instant instant2 = todt.atDate(LocalDate.now()).
                atZone(ZoneId.systemDefault()).toInstant();
        Date time2 = Date.from(instant2);
        Long toDate=time2.getTime();
        return toDate;
    }
    private Long fromDate() {
        LocalTime fromdt = LocalTime.of(00, 00,00);
        Instant instant = fromdt.atDate(LocalDate.now().minusDays(6)).
                atZone(ZoneId.systemDefault()).toInstant();
        Date time1 = Date.from(instant);
        Long fromDate=time1.getTime();
        return fromDate;
    }
    
   
	private List<WeeklyOrders> orderCountInCustomDate() {
		List<WeeklyOrders> orders = new ArrayList<>();
		Integer weekCount = 6;
		for (int i = weekCount; i >= 0; i--) {

			LocalTime fromdt = LocalTime.of(00, 00, 00);
			LocalTime todt = LocalTime.of(23, 59, 59);

			Instant instant = fromdt.atDate(LocalDate.now().minusDays(i)).atZone(ZoneId.systemDefault()).toInstant();
			Date time1 = Date.from(instant);
			Long fromDate = time1.getTime();

			Instant instant2 = todt.atDate(LocalDate.now().minusDays(i)).atZone(ZoneId.systemDefault()).toInstant();
			Date time2 = Date.from(instant2);
			Long toDate = time2.getTime();

			DynamicQuery dynamicQuery = new DynamicQuery();

			dynamicQuery.setOrderDateFrom(fromDate);
			dynamicQuery.setOrderDateTo(toDate);
			Long orderCount = ordersSummaryRepository.query(dynamicQuery);
			LocalDate formattedFromDate = Instant.ofEpochMilli(fromDate).atZone(ZoneId.systemDefault()).toLocalDate();
			WeeklyOrders order = new WeeklyOrders(formattedFromDate + "", orderCount);
			orders.add(order);

		}
		return orders;
	}
	
  public OrdersSummary getOrderSummaryCount(){
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("MM-dd-YYYY");
        LocalDateTime localTime = LocalDateTime.now();
        OrdersSummary ordersSummary=new OrdersSummary();
        ordersSummary.setOrderCountInMinute(this.orderCountInMinute());
        ordersSummary.setOrderCountInHour(this.orderCountInHour());
        ordersSummary.setOrderCountInDay(this.orderCountInDay());
        ordersSummary.setTotalCustomers(ordersSummaryRepository.queryCustomerCount().size());
        ordersSummary.setCurrentMinute(LocalTime.of(localTime.getHour(), localTime.getMinute(),00).toString());
        ordersSummary.setCurrentHour(LocalTime.of(localTime.getHour(), 00,00).toString());
        ordersSummary.setCurrentDate(simpleDateFormat.format(new Date()));
        return  ordersSummary;
    }

    @Override
    public List<WeeklyOrders> getOrderSummaryInWeek() {
    	
        return orderCountInCustomDate();
    }
  
    
}
