package com.nisum.omd.mongo.repository;

import com.mongodb.spark.MongoSpark;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.streaming.api.java.JavaDStream;
import org.apache.spark.streaming.api.java.JavaInputDStream;
import org.apache.spark.streaming.kafka010.CanCommitOffsets;
import org.apache.spark.streaming.kafka010.HasOffsetRanges;
import org.apache.spark.streaming.kafka010.OffsetRange;
import org.bson.Document;

public class OmdSparkStreamRepositoryImpl {

    public static void saveMongoData(JavaInputDStream<ConsumerRecord<String, String>> orderStream) {


        JavaDStream<ConsumerRecord<String, String>> recordJavaDStream =
                orderStream.filter(f -> !f.value().contains("\"orderNum\":0"));

        recordJavaDStream.foreachRDD((JavaRDD<ConsumerRecord<String, String>> r) -> {
            MongoSpark.save(
                    r.map(
                            e -> Document.parse(e.value())
                    )
            );
        });

        orderStream.foreachRDD((JavaRDD<ConsumerRecord<String, String>> javaRDD) -> {
            OffsetRange[] offsetRanges = ((HasOffsetRanges) javaRDD.rdd()).offsetRanges();

            ((CanCommitOffsets) orderStream.inputDStream())
                    .commitAsync(offsetRanges, new OrderOffsetCommitCallback());
        });

    }
}
